/**
 *
 *
  _____                      _              _ _ _     _   _     _        __ _ _
 |  __ \                    | |            | (_) |   | | | |   (_)      / _(_) |
 | |  | | ___    _ __   ___ | |_    ___  __| |_| |_  | |_| |__  _ ___  | |_ _| | ___
 | |  | |/ _ \  | '_ \ / _ \| __|  / _ \/ _` | | __| | __| '_ \| / __| |  _| | |/ _ \
 | |__| | (_) | | | | | (_) | |_  |  __/ (_| | | |_  | |_| | | | \__ \ | | | | |  __/
 |_____/ \___/  |_| |_|\___/ \__|  \___|\__,_|_|\__|  \__|_| |_|_|___/ |_| |_|_|\___|

 * DO NOT EDIT THIS FILE!!
 *
 *  FOR CUSTOMIZE empresaBaseService PLEASE EDIT ../empresa.service.ts
 *
 *  -- THIS FILE WILL BE OVERWRITTEN ON THE NEXT SKAFFOLDER'S CODE GENERATION --
 *
 */
 // DEPENDENCIES
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';
import { HttpClient } from '@angular/common/http';

// CONFIG
import { environment } from '../../../environments/environment';

// MODEL
import { Empresa } from '../../domain/gifloadmin_db/empresa';

/**
 * THIS SERVICE MAKE HTTP REQUEST TO SERVER, FOR CUSTOMIZE IT EDIT ../Empresa.service.ts
 */

/*
 * SCHEMA DB Empresa
 *
	{
		activo: {
			type: 'String'
		},
		calificacion: {
			type: 'Decimal'
		},
		contCalificacion: {
			type: 'Integer'
		},
		nombre: {
			type: 'String'
		},
		ruc: {
			type: 'String'
		},
		//RELATIONS
		//EXTERNAL RELATIONS
		usuarios: {
			type: Schema.ObjectId,
			ref : "Empresa"
		},
	}
 *
 */

export class EmpresaBaseService {

    contextUrl: string = environment.endpoint + '/empresa';
    constructor(
        protected http: HttpClient
        ) { }

    // CRUD METHODS

    /**
    * EmpresaService.get
    *   @description CRUD ACTION get
    *   @param ObjectId id Id Empresa
    *   @returns Empresa
    *
    */
    get(id: string): Observable<Empresa> {
        return this.http
            .get<Empresa>(this.contextUrl + '/' + id)
            .pipe(map(data => data));
    }

    /**
    * EmpresaService.list
    *   @description CRUD ACTION list
    *   @returns ARRAY OF Empresa
    *
    */
    list(): Observable<Empresa[]> {
        return this.http
            .get<Empresa[]>(this.contextUrl)
            .pipe(map(data => data));
    }

    /**
    * EmpresaService.update
    *   @description CRUD ACTION update
    *   @param ObjectId id Id Empresa
    *   @returns Empresa
    *
    */
    update(item: Empresa): Observable<Empresa> {
        return this.http
            .post<Empresa>(this.contextUrl + '/' + item._id, item)
            .pipe(map(data => data));
    }


    // Custom APIs

}
